#!/usr/bin/env python
# -*- coding: utf-8 -*-

#
# Generated Thu Apr 20 13:55:47 2017 by generateDS.py version 2.25a.
#
# Command line options:
#   ('--silence', '')
#   ('-o', '../obsxml_parser.py')
#
# Command line arguments:
#   Observation.xsd
#
# Command line:
#   /Users/caseyjlaw/anaconda/envs/py36/bin/generateDS.py --silence -o "../obsxml_parser.py" Observation.xsd
#
# Current working directory (os.getcwd()):
#   xsd
#

import sys
import re as re_
import base64
import datetime as datetime_
import warnings as warnings_
try:
    from lxml import etree as etree_
except ImportError:
    from xml.etree import ElementTree as etree_


Validate_simpletypes_ = True
if sys.version_info.major == 2:
    BaseStrType_ = basestring
else:
    BaseStrType_ = str


def parsexml_(infile, parser=None, **kwargs):
    if parser is None:
        # Use the lxml ElementTree compatible parser so that, e.g.,
        #   we ignore comments.
        try:
            parser = etree_.ETCompatXMLParser()
        except AttributeError:
            # fallback to xml.etree
            parser = etree_.XMLParser()
    doc = etree_.parse(infile, parser=parser, **kwargs)
    return doc

#
# User methods
#
# Calls to the methods in these classes are generated by generateDS.py.
# You can replace these methods by re-implementing the following class
#   in a module named generatedssuper.py.

try:
    from generatedssuper import GeneratedsSuper
except ImportError as exp:

    class GeneratedsSuper(object):
        tzoff_pattern = re_.compile(r'(\+|-)((0\d|1[0-3]):[0-5]\d|14:00)$')
        class _FixedOffsetTZ(datetime_.tzinfo):
            def __init__(self, offset, name):
                self.__offset = datetime_.timedelta(minutes=offset)
                self.__name = name
            def utcoffset(self, dt):
                return self.__offset
            def tzname(self, dt):
                return self.__name
            def dst(self, dt):
                return None
        def gds_format_string(self, input_data, input_name=''):
            return input_data
        def gds_validate_string(self, input_data, node=None, input_name=''):
            if not input_data:
                return ''
            else:
                return input_data
        def gds_format_base64(self, input_data, input_name=''):
            return base64.b64encode(input_data)
        def gds_validate_base64(self, input_data, node=None, input_name=''):
            return input_data
        def gds_format_integer(self, input_data, input_name=''):
            return '%d' % input_data
        def gds_validate_integer(self, input_data, node=None, input_name=''):
            return input_data
        def gds_format_integer_list(self, input_data, input_name=''):
            return '%s' % ' '.join(input_data)
        def gds_validate_integer_list(
                self, input_data, node=None, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    int(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of integers')
            return values
        def gds_format_float(self, input_data, input_name=''):
            return ('%.15f' % input_data).rstrip('0')
        def gds_validate_float(self, input_data, node=None, input_name=''):
            return input_data
        def gds_format_float_list(self, input_data, input_name=''):
            return '%s' % ' '.join(input_data)
        def gds_validate_float_list(
                self, input_data, node=None, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    float(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of floats')
            return values
        def gds_format_double(self, input_data, input_name=''):
            return '%e' % input_data
        def gds_validate_double(self, input_data, node=None, input_name=''):
            return input_data
        def gds_format_double_list(self, input_data, input_name=''):
            return '%s' % ' '.join(input_data)
        def gds_validate_double_list(
                self, input_data, node=None, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    float(value)
                except (TypeError, ValueError):
                    raise_parse_error(node, 'Requires sequence of doubles')
            return values
        def gds_format_boolean(self, input_data, input_name=''):
            return ('%s' % input_data).lower()
        def gds_validate_boolean(self, input_data, node=None, input_name=''):
            return input_data
        def gds_format_boolean_list(self, input_data, input_name=''):
            return '%s' % ' '.join(input_data)
        def gds_validate_boolean_list(
                self, input_data, node=None, input_name=''):
            values = input_data.split()
            for value in values:
                if value not in ('true', '1', 'false', '0', ):
                    raise_parse_error(
                        node,
                        'Requires sequence of booleans '
                        '("true", "1", "false", "0")')
            return values
        def gds_validate_datetime(self, input_data, node=None, input_name=''):
            return input_data
        def gds_format_datetime(self, input_data, input_name=''):
            if input_data.microsecond == 0:
                _svalue = '%04d-%02d-%02dT%02d:%02d:%02d' % (
                    input_data.year,
                    input_data.month,
                    input_data.day,
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                )
            else:
                _svalue = '%04d-%02d-%02dT%02d:%02d:%02d.%s' % (
                    input_data.year,
                    input_data.month,
                    input_data.day,
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                    ('%f' % (float(input_data.microsecond) / 1000000))[2:],
                )
            if input_data.tzinfo is not None:
                tzoff = input_data.tzinfo.utcoffset(input_data)
                if tzoff is not None:
                    total_seconds = tzoff.seconds + (86400 * tzoff.days)
                    if total_seconds == 0:
                        _svalue += 'Z'
                    else:
                        if total_seconds < 0:
                            _svalue += '-'
                            total_seconds *= -1
                        else:
                            _svalue += '+'
                        hours = total_seconds // 3600
                        minutes = (total_seconds - (hours * 3600)) // 60
                        _svalue += '{0:02d}:{1:02d}'.format(hours, minutes)
            return _svalue
        @classmethod
        def gds_parse_datetime(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            time_parts = input_data.split('.')
            if len(time_parts) > 1:
                micro_seconds = int(float('0.' + time_parts[1]) * 1000000)
                input_data = '%s.%s' % (time_parts[0], micro_seconds, )
                dt = datetime_.datetime.strptime(
                    input_data, '%Y-%m-%dT%H:%M:%S.%f')
            else:
                dt = datetime_.datetime.strptime(
                    input_data, '%Y-%m-%dT%H:%M:%S')
            dt = dt.replace(tzinfo=tz)
            return dt
        def gds_validate_date(self, input_data, node=None, input_name=''):
            return input_data
        def gds_format_date(self, input_data, input_name=''):
            _svalue = '%04d-%02d-%02d' % (
                input_data.year,
                input_data.month,
                input_data.day,
            )
            try:
                if input_data.tzinfo is not None:
                    tzoff = input_data.tzinfo.utcoffset(input_data)
                    if tzoff is not None:
                        total_seconds = tzoff.seconds + (86400 * tzoff.days)
                        if total_seconds == 0:
                            _svalue += 'Z'
                        else:
                            if total_seconds < 0:
                                _svalue += '-'
                                total_seconds *= -1
                            else:
                                _svalue += '+'
                            hours = total_seconds // 3600
                            minutes = (total_seconds - (hours * 3600)) // 60
                            _svalue += '{0:02d}:{1:02d}'.format(
                                hours, minutes)
            except AttributeError:
                pass
            return _svalue
        @classmethod
        def gds_parse_date(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            dt = datetime_.datetime.strptime(input_data, '%Y-%m-%d')
            dt = dt.replace(tzinfo=tz)
            return dt.date()
        def gds_validate_time(self, input_data, node=None, input_name=''):
            return input_data
        def gds_format_time(self, input_data, input_name=''):
            if input_data.microsecond == 0:
                _svalue = '%02d:%02d:%02d' % (
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                )
            else:
                _svalue = '%02d:%02d:%02d.%s' % (
                    input_data.hour,
                    input_data.minute,
                    input_data.second,
                    ('%f' % (float(input_data.microsecond) / 1000000))[2:],
                )
            if input_data.tzinfo is not None:
                tzoff = input_data.tzinfo.utcoffset(input_data)
                if tzoff is not None:
                    total_seconds = tzoff.seconds + (86400 * tzoff.days)
                    if total_seconds == 0:
                        _svalue += 'Z'
                    else:
                        if total_seconds < 0:
                            _svalue += '-'
                            total_seconds *= -1
                        else:
                            _svalue += '+'
                        hours = total_seconds // 3600
                        minutes = (total_seconds - (hours * 3600)) // 60
                        _svalue += '{0:02d}:{1:02d}'.format(hours, minutes)
            return _svalue
        def gds_validate_simple_patterns(self, patterns, target):
            # pat is a list of lists of strings/patterns.  We should:
            # - AND the outer elements
            # - OR the inner elements
            found1 = True
            for patterns1 in patterns:
                found2 = False
                for patterns2 in patterns1:
                    if re_.search(patterns2, target) is not None:
                        found2 = True
                        break
                if not found2:
                    found1 = False
                    break
            return found1
        @classmethod
        def gds_parse_time(cls, input_data):
            tz = None
            if input_data[-1] == 'Z':
                tz = GeneratedsSuper._FixedOffsetTZ(0, 'UTC')
                input_data = input_data[:-1]
            else:
                results = GeneratedsSuper.tzoff_pattern.search(input_data)
                if results is not None:
                    tzoff_parts = results.group(2).split(':')
                    tzoff = int(tzoff_parts[0]) * 60 + int(tzoff_parts[1])
                    if results.group(1) == '-':
                        tzoff *= -1
                    tz = GeneratedsSuper._FixedOffsetTZ(
                        tzoff, results.group(0))
                    input_data = input_data[:-6]
            if len(input_data.split('.')) > 1:
                dt = datetime_.datetime.strptime(input_data, '%H:%M:%S.%f')
            else:
                dt = datetime_.datetime.strptime(input_data, '%H:%M:%S')
            dt = dt.replace(tzinfo=tz)
            return dt.time()
        def gds_str_lower(self, instring):
            return instring.lower()
        def get_path_(self, node):
            path_list = []
            self.get_path_list_(node, path_list)
            path_list.reverse()
            path = '/'.join(path_list)
            return path
        Tag_strip_pattern_ = re_.compile(r'\{.*\}')
        def get_path_list_(self, node, path_list):
            if node is None:
                return
            tag = GeneratedsSuper.Tag_strip_pattern_.sub('', node.tag)
            if tag:
                path_list.append(tag)
            self.get_path_list_(node.getparent(), path_list)
        def get_class_obj_(self, node, default_class=None):
            class_obj1 = default_class
            if 'xsi' in node.nsmap:
                classname = node.get('{%s}type' % node.nsmap['xsi'])
                if classname is not None:
                    names = classname.split(':')
                    if len(names) == 2:
                        classname = names[1]
                    class_obj2 = globals().get(classname)
                    if class_obj2 is not None:
                        class_obj1 = class_obj2
            return class_obj1
        def gds_build_any(self, node, type_name=None):
            return None
        @classmethod
        def gds_reverse_node_mapping(cls, mapping):
            return dict(((v, k) for k, v in mapping.iteritems()))
        @staticmethod
        def gds_encode(instring):
            if sys.version_info.major == 2:
                return instring.encode(ExternalEncoding)
            else:
                return instring
        @staticmethod
        def convert_unicode(instring):
            if isinstance(instring, str):
                result = quote_xml(instring)
            elif sys.version_info.major == 2 and isinstance(instring, unicode):
                result = quote_xml(instring).encode('utf8')
            else:
                result = GeneratedsSuper.gds_encode(str(instring))
            return result

    def getSubclassFromModule_(module, class_):
        '''Get the subclass of a class from a specific module.'''
        name = class_.__name__ + 'Sub'
        if hasattr(module, name):
            return getattr(module, name)
        else:
            return None


#
# If you have installed IPython you can uncomment and use the following.
# IPython is available from http://ipython.scipy.org/.
#

## from IPython.Shell import IPShellEmbed
## args = ''
## ipshell = IPShellEmbed(args,
##     banner = 'Dropping into IPython',
##     exit_msg = 'Leaving Interpreter, back to program.')

# Then use the following line where and when you want to drop into the
# IPython shell:
#    ipshell('<some message> -- Entering ipshell.\nHit Ctrl-D to exit')

#
# Globals
#

ExternalEncoding = 'utf-8'
Tag_pattern_ = re_.compile(r'({.*})?(.*)')
String_cleanup_pat_ = re_.compile(r"[\n\r\s]+")
Namespace_extract_pat_ = re_.compile(r'{(.*)}(.*)')
CDATA_pattern_ = re_.compile(r"<!\[CDATA\[.*?\]\]>", re_.DOTALL)

# Change this to redirect the generated superclass module to use a
# specific subclass module.
CurrentSubclassModule_ = None

#
# Support/utility functions.
#


def showIndent(outfile, level, pretty_print=True):
    if pretty_print:
        for idx in range(level):
            outfile.write('    ')


def quote_xml(inStr):
    "Escape markup chars, but do not modify CDATA sections."
    if not inStr:
        return ''
    s1 = (isinstance(inStr, BaseStrType_) and inStr or '%s' % inStr)
    s2 = ''
    pos = 0
    matchobjects = CDATA_pattern_.finditer(s1)
    for mo in matchobjects:
        s3 = s1[pos:mo.start()]
        s2 += quote_xml_aux(s3)
        s2 += s1[mo.start():mo.end()]
        pos = mo.end()
    s3 = s1[pos:]
    s2 += quote_xml_aux(s3)
    return s2


def quote_xml_aux(inStr):
    s1 = inStr.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1


def quote_attrib(inStr):
    s1 = (isinstance(inStr, BaseStrType_) and inStr or '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    if '"' in s1:
        if "'" in s1:
            s1 = '"%s"' % s1.replace('"', "&quot;")
        else:
            s1 = "'%s'" % s1
    else:
        s1 = '"%s"' % s1
    return s1


def quote_python(inStr):
    s1 = inStr
    if s1.find("'") == -1:
        if s1.find('\n') == -1:
            return "'%s'" % s1
        else:
            return "'''%s'''" % s1
    else:
        if s1.find('"') != -1:
            s1 = s1.replace('"', '\\"')
        if s1.find('\n') == -1:
            return '"%s"' % s1
        else:
            return '"""%s"""' % s1


def get_all_text_(node):
    if node.text is not None:
        text = node.text
    else:
        text = ''
    for child in node:
        if child.tail is not None:
            text += child.tail
    return text


def find_attr_value_(attr_name, node):
    attrs = node.attrib
    attr_parts = attr_name.split(':')
    value = None
    if len(attr_parts) == 1:
        value = attrs.get(attr_name)
    elif len(attr_parts) == 2:
        prefix, name = attr_parts
        namespace = node.nsmap.get(prefix)
        if namespace is not None:
            value = attrs.get('{%s}%s' % (namespace, name, ))
    return value


class GDSParseError(Exception):
    pass


def raise_parse_error(node, msg):
    msg = '%s (element %s/line %d)' % (msg, node.tag, node.sourceline, )
    raise GDSParseError(msg)


class MixedContainer:
    # Constants for category:
    CategoryNone = 0
    CategoryText = 1
    CategorySimple = 2
    CategoryComplex = 3
    # Constants for content_type:
    TypeNone = 0
    TypeText = 1
    TypeString = 2
    TypeInteger = 3
    TypeFloat = 4
    TypeDecimal = 5
    TypeDouble = 6
    TypeBoolean = 7
    TypeBase64 = 8
    def __init__(self, category, content_type, name, value):
        self.category = category
        self.content_type = content_type
        self.name = name
        self.value = value
    def getCategory(self):
        return self.category
    def getContenttype(self, content_type):
        return self.content_type
    def getValue(self):
        return self.value
    def getName(self):
        return self.name
    def export(self, outfile, level, name, namespace, pretty_print=True):
        if self.category == MixedContainer.CategoryText:
            # Prevent exporting empty content as empty lines.
            if self.value.strip():
                outfile.write(self.value)
        elif self.category == MixedContainer.CategorySimple:
            self.exportSimple(outfile, level, name)
        else:    # category == MixedContainer.CategoryComplex
            self.value.export(
                outfile, level, namespace, name, pretty_print=pretty_print)
    def exportSimple(self, outfile, level, name):
        if self.content_type == MixedContainer.TypeString:
            outfile.write('<%s>%s</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeInteger or \
                self.content_type == MixedContainer.TypeBoolean:
            outfile.write('<%s>%d</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeFloat or \
                self.content_type == MixedContainer.TypeDecimal:
            outfile.write('<%s>%f</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeDouble:
            outfile.write('<%s>%g</%s>' % (
                self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeBase64:
            outfile.write('<%s>%s</%s>' % (
                self.name, base64.b64encode(self.value), self.name))
    def to_etree(self, element):
        if self.category == MixedContainer.CategoryText:
            # Prevent exporting empty content as empty lines.
            if self.value.strip():
                if len(element) > 0:
                    if element[-1].tail is None:
                        element[-1].tail = self.value
                    else:
                        element[-1].tail += self.value
                else:
                    if element.text is None:
                        element.text = self.value
                    else:
                        element.text += self.value
        elif self.category == MixedContainer.CategorySimple:
            subelement = etree_.SubElement(element, '%s' % self.name)
            subelement.text = self.to_etree_simple()
        else:    # category == MixedContainer.CategoryComplex
            self.value.to_etree(element)
    def to_etree_simple(self):
        if self.content_type == MixedContainer.TypeString:
            text = self.value
        elif (self.content_type == MixedContainer.TypeInteger or
                self.content_type == MixedContainer.TypeBoolean):
            text = '%d' % self.value
        elif (self.content_type == MixedContainer.TypeFloat or
                self.content_type == MixedContainer.TypeDecimal):
            text = '%f' % self.value
        elif self.content_type == MixedContainer.TypeDouble:
            text = '%g' % self.value
        elif self.content_type == MixedContainer.TypeBase64:
            text = '%s' % base64.b64encode(self.value)
        return text
    def exportLiteral(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s", "%s"),\n' % (
                    self.category, self.content_type, self.name, self.value))
        elif self.category == MixedContainer.CategorySimple:
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s", "%s"),\n' % (
                    self.category, self.content_type, self.name, self.value))
        else:    # category == MixedContainer.CategoryComplex
            showIndent(outfile, level)
            outfile.write(
                'model_.MixedContainer(%d, %d, "%s",\n' % (
                    self.category, self.content_type, self.name,))
            self.value.exportLiteral(outfile, level + 1)
            showIndent(outfile, level)
            outfile.write(')\n')


class MemberSpec_(object):
    def __init__(self, name='', data_type='', container=0, optional=0):
        self.name = name
        self.data_type = data_type
        self.container = container
        self.optional = optional
    def set_name(self, name): self.name = name
    def get_name(self): return self.name
    def set_data_type(self, data_type): self.data_type = data_type
    def get_data_type_chain(self): return self.data_type
    def get_data_type(self):
        if isinstance(self.data_type, list):
            if len(self.data_type) > 0:
                return self.data_type[-1]
            else:
                return 'xs:string'
        else:
            return self.data_type
    def set_container(self, container): self.container = container
    def get_container(self): return self.container
    def set_optional(self, optional): self.optional = optional
    def get_optional(self): return self.optional


def _cast(typ, value):
    if typ is None or value is None:
        return value
    return typ(value)

#
# Data representation classes.
#


class Observation(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, subarrayId=None, datasetId=None, startTime=None, seq=None, configId=None, configUrl=None, name=None, ra=None, dec=None, dra=None, ddec=None, ephemeris=None, azoffs=None, eloffs=None, startLST=None, intent=None, state=None, scanNo=None, subscanNo=None, modifier=None, correlator=None, sslo=None):
        self.original_tagname_ = None
        self.subarrayId = _cast(None, subarrayId)
        self.datasetId = _cast(None, datasetId)
        self.startTime = _cast(float, startTime)
        self.seq = _cast(int, seq)
        self.configId = _cast(None, configId)
        self.configUrl = _cast(None, configUrl)
        self.name = name
        self.ra = ra
        self.dec = dec
        self.dra = dra
        self.ddec = ddec
        self.ephemeris = ephemeris
        self.azoffs = azoffs
        self.eloffs = eloffs
        self.startLST = startLST
        if intent is None:
            self.intent = []
        else:
            self.intent = intent
        self.state = state
        self.scanNo = scanNo
        self.subscanNo = subscanNo
        if modifier is None:
            self.modifier = []
        else:
            self.modifier = modifier
        self.correlator = correlator
        if sslo is None:
            self.sslo = []
        else:
            self.sslo = sslo
    def factory(*args_, **kwargs_):
        if CurrentSubclassModule_ is not None:
            subclass = getSubclassFromModule_(
                CurrentSubclassModule_, Observation)
            if subclass is not None:
                return subclass(*args_, **kwargs_)
        if Observation.subclass:
            return Observation.subclass(*args_, **kwargs_)
        else:
            return Observation(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_name(self): return self.name
    def set_name(self, name): self.name = name
    def get_ra(self): return self.ra
    def set_ra(self, ra): self.ra = ra
    def get_dec(self): return self.dec
    def set_dec(self, dec): self.dec = dec
    def get_dra(self): return self.dra
    def set_dra(self, dra): self.dra = dra
    def get_ddec(self): return self.ddec
    def set_ddec(self, ddec): self.ddec = ddec
    def get_ephemeris(self): return self.ephemeris
    def set_ephemeris(self, ephemeris): self.ephemeris = ephemeris
    def get_azoffs(self): return self.azoffs
    def set_azoffs(self, azoffs): self.azoffs = azoffs
    def get_eloffs(self): return self.eloffs
    def set_eloffs(self, eloffs): self.eloffs = eloffs
    def get_startLST(self): return self.startLST
    def set_startLST(self, startLST): self.startLST = startLST
    def get_intent(self): return self.intent
    def set_intent(self, intent): self.intent = intent
    def add_intent(self, value): self.intent.append(value)
    def insert_intent_at(self, index, value): self.intent.insert(index, value)
    def replace_intent_at(self, index, value): self.intent[index] = value
    def get_state(self): return self.state
    def set_state(self, state): self.state = state
    def get_scanNo(self): return self.scanNo
    def set_scanNo(self, scanNo): self.scanNo = scanNo
    def get_subscanNo(self): return self.subscanNo
    def set_subscanNo(self, subscanNo): self.subscanNo = subscanNo
    def get_modifier(self): return self.modifier
    def set_modifier(self, modifier): self.modifier = modifier
    def add_modifier(self, value): self.modifier.append(value)
    def insert_modifier_at(self, index, value): self.modifier.insert(index, value)
    def replace_modifier_at(self, index, value): self.modifier[index] = value
    def get_correlator(self): return self.correlator
    def set_correlator(self, correlator): self.correlator = correlator
    def get_sslo(self): return self.sslo
    def set_sslo(self, sslo): self.sslo = sslo
    def add_sslo(self, value): self.sslo.append(value)
    def insert_sslo_at(self, index, value): self.sslo.insert(index, value)
    def replace_sslo_at(self, index, value): self.sslo[index] = value
    def get_subarrayId(self): return self.subarrayId
    def set_subarrayId(self, subarrayId): self.subarrayId = subarrayId
    def get_datasetId(self): return self.datasetId
    def set_datasetId(self, datasetId): self.datasetId = datasetId
    def get_startTime(self): return self.startTime
    def set_startTime(self, startTime): self.startTime = startTime
    def get_seq(self): return self.seq
    def set_seq(self, seq): self.seq = seq
    def get_configId(self): return self.configId
    def set_configId(self, configId): self.configId = configId
    def get_configUrl(self): return self.configUrl
    def set_configUrl(self, configUrl): self.configUrl = configUrl
    def hasContent_(self):
        if (
            self.name is not None or
            self.ra is not None or
            self.dec is not None or
            self.dra is not None or
            self.ddec is not None or
            self.ephemeris is not None or
            self.azoffs is not None or
            self.eloffs is not None or
            self.startLST is not None or
            self.intent or
            self.state is not None or
            self.scanNo is not None or
            self.subscanNo is not None or
            self.modifier or
            self.correlator is not None or
            self.sslo
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='', name_='Observation', namespacedef_='', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='Observation')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='', name_='Observation', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='Observation'):
        if self.subarrayId is not None and 'subarrayId' not in already_processed:
            already_processed.add('subarrayId')
            outfile.write(' subarrayId=%s' % (self.gds_encode(self.gds_format_string(quote_attrib(self.subarrayId), input_name='subarrayId')), ))
        if self.datasetId is not None and 'datasetId' not in already_processed:
            already_processed.add('datasetId')
            outfile.write(' datasetId=%s' % (self.gds_encode(self.gds_format_string(quote_attrib(self.datasetId), input_name='datasetId')), ))
        if self.startTime is not None and 'startTime' not in already_processed:
            already_processed.add('startTime')
            outfile.write(' startTime="%s"' % self.gds_format_double(self.startTime, input_name='startTime'))
        if self.seq is not None and 'seq' not in already_processed:
            already_processed.add('seq')
            outfile.write(' seq="%s"' % self.gds_format_integer(self.seq, input_name='seq'))
        if self.configId is not None and 'configId' not in already_processed:
            already_processed.add('configId')
            outfile.write(' configId=%s' % (self.gds_encode(self.gds_format_string(quote_attrib(self.configId), input_name='configId')), ))
        if self.configUrl is not None and 'configUrl' not in already_processed:
            already_processed.add('configUrl')
            outfile.write(' configUrl=%s' % (self.gds_encode(self.gds_format_string(quote_attrib(self.configUrl), input_name='configUrl')), ))
    def exportChildren(self, outfile, level, namespace_='', name_='Observation', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.name is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sname>%s</%sname>%s' % (namespace_, self.gds_encode(self.gds_format_string(quote_xml(self.name), input_name='name')), namespace_, eol_))
        if self.ra is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sra>%s</%sra>%s' % (namespace_, self.gds_format_double(self.ra, input_name='ra'), namespace_, eol_))
        if self.dec is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sdec>%s</%sdec>%s' % (namespace_, self.gds_format_double(self.dec, input_name='dec'), namespace_, eol_))
        if self.dra is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sdra>%s</%sdra>%s' % (namespace_, self.gds_format_double(self.dra, input_name='dra'), namespace_, eol_))
        if self.ddec is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sddec>%s</%sddec>%s' % (namespace_, self.gds_format_double(self.ddec, input_name='ddec'), namespace_, eol_))
        if self.ephemeris is not None:
            self.ephemeris.export(outfile, level, namespace_, name_='ephemeris', pretty_print=pretty_print)
        if self.azoffs is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sazoffs>%s</%sazoffs>%s' % (namespace_, self.gds_format_double(self.azoffs, input_name='azoffs'), namespace_, eol_))
        if self.eloffs is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%seloffs>%s</%seloffs>%s' % (namespace_, self.gds_format_double(self.eloffs, input_name='eloffs'), namespace_, eol_))
        if self.startLST is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sstartLST>%s</%sstartLST>%s' % (namespace_, self.gds_format_double(self.startLST, input_name='startLST'), namespace_, eol_))
        for intent_ in self.intent:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sintent>%s</%sintent>%s' % (namespace_, self.gds_encode(self.gds_format_string(quote_xml(intent_), input_name='intent')), namespace_, eol_))
        if self.state is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sstate>%s</%sstate>%s' % (namespace_, self.gds_format_integer(self.state, input_name='state'), namespace_, eol_))
        if self.scanNo is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sscanNo>%s</%sscanNo>%s' % (namespace_, self.gds_format_integer(self.scanNo, input_name='scanNo'), namespace_, eol_))
        if self.subscanNo is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%ssubscanNo>%s</%ssubscanNo>%s' % (namespace_, self.gds_format_integer(self.subscanNo, input_name='subscanNo'), namespace_, eol_))
        for modifier_ in self.modifier:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%smodifier>%s</%smodifier>%s' % (namespace_, self.gds_encode(self.gds_format_string(quote_xml(modifier_), input_name='modifier')), namespace_, eol_))
        if self.correlator is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%scorrelator>%s</%scorrelator>%s' % (namespace_, self.gds_encode(self.gds_format_string(quote_xml(self.correlator), input_name='correlator')), namespace_, eol_))
        for sslo_ in self.sslo:
            sslo_.export(outfile, level, namespace_, name_='sslo', pretty_print=pretty_print)
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('subarrayId', node)
        if value is not None and 'subarrayId' not in already_processed:
            already_processed.add('subarrayId')
            self.subarrayId = value
        value = find_attr_value_('datasetId', node)
        if value is not None and 'datasetId' not in already_processed:
            already_processed.add('datasetId')
            self.datasetId = value
        value = find_attr_value_('startTime', node)
        if value is not None and 'startTime' not in already_processed:
            already_processed.add('startTime')
            try:
                self.startTime = float(value)
            except ValueError as exp:
                raise ValueError('Bad float/double attribute (startTime): %s' % exp)
        value = find_attr_value_('seq', node)
        if value is not None and 'seq' not in already_processed:
            already_processed.add('seq')
            try:
                self.seq = int(value)
            except ValueError as exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
        value = find_attr_value_('configId', node)
        if value is not None and 'configId' not in already_processed:
            already_processed.add('configId')
            self.configId = value
        value = find_attr_value_('configUrl', node)
        if value is not None and 'configUrl' not in already_processed:
            already_processed.add('configUrl')
            self.configUrl = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'name':
            name_ = child_.text
            name_ = self.gds_validate_string(name_, node, 'name')
            self.name = name_
        elif nodeName_ == 'ra':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'ra')
            self.ra = fval_
        elif nodeName_ == 'dec':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'dec')
            self.dec = fval_
        elif nodeName_ == 'dra':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'dra')
            self.dra = fval_
        elif nodeName_ == 'ddec':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'ddec')
            self.ddec = fval_
        elif nodeName_ == 'ephemeris':
            obj_ = ephemerisType.factory()
            obj_.build(child_)
            self.ephemeris = obj_
            obj_.original_tagname_ = 'ephemeris'
        elif nodeName_ == 'azoffs':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'azoffs')
            self.azoffs = fval_
        elif nodeName_ == 'eloffs':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'eloffs')
            self.eloffs = fval_
        elif nodeName_ == 'startLST':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'startLST')
            self.startLST = fval_
        elif nodeName_ == 'intent':
            intent_ = child_.text
            intent_ = self.gds_validate_string(intent_, node, 'intent')
            self.intent.append(intent_)
        elif nodeName_ == 'state':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'state')
            self.state = ival_
        elif nodeName_ == 'scanNo':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'scanNo')
            self.scanNo = ival_
        elif nodeName_ == 'subscanNo':
            sval_ = child_.text
            try:
                ival_ = int(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires integer: %s' % exp)
            ival_ = self.gds_validate_integer(ival_, node, 'subscanNo')
            self.subscanNo = ival_
        elif nodeName_ == 'modifier':
            modifier_ = child_.text
            modifier_ = self.gds_validate_string(modifier_, node, 'modifier')
            self.modifier.append(modifier_)
        elif nodeName_ == 'correlator':
            correlator_ = child_.text
            correlator_ = self.gds_validate_string(correlator_, node, 'correlator')
            self.correlator = correlator_
        elif nodeName_ == 'sslo':
            obj_ = ssloType.factory()
            obj_.build(child_)
            self.sslo.append(obj_)
            obj_.original_tagname_ = 'sslo'
# end class Observation


class polyType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, coeff=None):
        self.original_tagname_ = None
        if coeff is None:
            self.coeff = []
        else:
            self.coeff = coeff
    def factory(*args_, **kwargs_):
        if CurrentSubclassModule_ is not None:
            subclass = getSubclassFromModule_(
                CurrentSubclassModule_, polyType)
            if subclass is not None:
                return subclass(*args_, **kwargs_)
        if polyType.subclass:
            return polyType.subclass(*args_, **kwargs_)
        else:
            return polyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_coeff(self): return self.coeff
    def set_coeff(self, coeff): self.coeff = coeff
    def add_coeff(self, value): self.coeff.append(value)
    def insert_coeff_at(self, index, value): self.coeff.insert(index, value)
    def replace_coeff_at(self, index, value): self.coeff[index] = value
    def hasContent_(self):
        if (
            self.coeff
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='', name_='polyType', namespacedef_='', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='polyType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='', name_='polyType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='polyType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='polyType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        for coeff_ in self.coeff:
            coeff_.export(outfile, level, namespace_, name_='coeff', pretty_print=pretty_print)
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'coeff':
            obj_ = coeffType.factory()
            obj_.build(child_)
            self.coeff.append(obj_)
            obj_.original_tagname_ = 'coeff'
# end class polyType


class ephemerisType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, referenceTime=None, ra_polynomial=None, dec_polynomial=None, dist_polynomial=None, origin=None):
        self.original_tagname_ = None
        self.referenceTime = referenceTime
        self.ra_polynomial = ra_polynomial
        self.dec_polynomial = dec_polynomial
        self.dist_polynomial = dist_polynomial
        self.origin = origin
    def factory(*args_, **kwargs_):
        if CurrentSubclassModule_ is not None:
            subclass = getSubclassFromModule_(
                CurrentSubclassModule_, ephemerisType)
            if subclass is not None:
                return subclass(*args_, **kwargs_)
        if ephemerisType.subclass:
            return ephemerisType.subclass(*args_, **kwargs_)
        else:
            return ephemerisType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_referenceTime(self): return self.referenceTime
    def set_referenceTime(self, referenceTime): self.referenceTime = referenceTime
    def get_ra_polynomial(self): return self.ra_polynomial
    def set_ra_polynomial(self, ra_polynomial): self.ra_polynomial = ra_polynomial
    def get_dec_polynomial(self): return self.dec_polynomial
    def set_dec_polynomial(self, dec_polynomial): self.dec_polynomial = dec_polynomial
    def get_dist_polynomial(self): return self.dist_polynomial
    def set_dist_polynomial(self, dist_polynomial): self.dist_polynomial = dist_polynomial
    def get_origin(self): return self.origin
    def set_origin(self, origin): self.origin = origin
    def hasContent_(self):
        if (
            self.referenceTime is not None or
            self.ra_polynomial is not None or
            self.dec_polynomial is not None or
            self.dist_polynomial is not None or
            self.origin is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='', name_='ephemerisType', namespacedef_='', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ephemerisType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='', name_='ephemerisType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ephemerisType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ephemerisType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.referenceTime is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sreferenceTime>%s</%sreferenceTime>%s' % (namespace_, self.gds_format_double(self.referenceTime, input_name='referenceTime'), namespace_, eol_))
        if self.ra_polynomial is not None:
            self.ra_polynomial.export(outfile, level, namespace_, name_='ra_polynomial', pretty_print=pretty_print)
        if self.dec_polynomial is not None:
            self.dec_polynomial.export(outfile, level, namespace_, name_='dec_polynomial', pretty_print=pretty_print)
        if self.dist_polynomial is not None:
            self.dist_polynomial.export(outfile, level, namespace_, name_='dist_polynomial', pretty_print=pretty_print)
        if self.origin is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sorigin>%s</%sorigin>%s' % (namespace_, self.gds_encode(self.gds_format_string(quote_xml(self.origin), input_name='origin')), namespace_, eol_))
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        pass
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'referenceTime':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'referenceTime')
            self.referenceTime = fval_
        elif nodeName_ == 'ra_polynomial':
            obj_ = polyType.factory()
            obj_.build(child_)
            self.ra_polynomial = obj_
            obj_.original_tagname_ = 'ra_polynomial'
        elif nodeName_ == 'dec_polynomial':
            obj_ = polyType.factory()
            obj_.build(child_)
            self.dec_polynomial = obj_
            obj_.original_tagname_ = 'dec_polynomial'
        elif nodeName_ == 'dist_polynomial':
            obj_ = polyType.factory()
            obj_.build(child_)
            self.dist_polynomial = obj_
            obj_.original_tagname_ = 'dist_polynomial'
        elif nodeName_ == 'origin':
            origin_ = child_.text
            origin_ = self.gds_validate_string(origin_, node, 'origin')
            self.origin = origin_
# end class ephemerisType


class ssloType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Receiver=None, IFid=None, Sideband=None, SolarCal=None, freq=None):
        self.original_tagname_ = None
        self.Receiver = _cast(None, Receiver)
        self.IFid = _cast(None, IFid)
        self.Sideband = _cast(int, Sideband)
        self.SolarCal = _cast(int, SolarCal)
        self.freq = freq
    def factory(*args_, **kwargs_):
        if CurrentSubclassModule_ is not None:
            subclass = getSubclassFromModule_(
                CurrentSubclassModule_, ssloType)
            if subclass is not None:
                return subclass(*args_, **kwargs_)
        if ssloType.subclass:
            return ssloType.subclass(*args_, **kwargs_)
        else:
            return ssloType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_freq(self): return self.freq
    def set_freq(self, freq): self.freq = freq
    def get_Receiver(self): return self.Receiver
    def set_Receiver(self, Receiver): self.Receiver = Receiver
    def get_IFid(self): return self.IFid
    def set_IFid(self, IFid): self.IFid = IFid
    def get_Sideband(self): return self.Sideband
    def set_Sideband(self, Sideband): self.Sideband = Sideband
    def get_SolarCal(self): return self.SolarCal
    def set_SolarCal(self, SolarCal): self.SolarCal = SolarCal
    def hasContent_(self):
        if (
            self.freq is not None
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='', name_='ssloType', namespacedef_='', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ssloType')
        if self.hasContent_():
            outfile.write('>%s' % (eol_, ))
            self.exportChildren(outfile, level + 1, namespace_='', name_='ssloType', pretty_print=pretty_print)
            showIndent(outfile, level, pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ssloType'):
        if self.Receiver is not None and 'Receiver' not in already_processed:
            already_processed.add('Receiver')
            outfile.write(' Receiver=%s' % (self.gds_encode(self.gds_format_string(quote_attrib(self.Receiver), input_name='Receiver')), ))
        if self.IFid is not None and 'IFid' not in already_processed:
            already_processed.add('IFid')
            outfile.write(' IFid=%s' % (self.gds_encode(self.gds_format_string(quote_attrib(self.IFid), input_name='IFid')), ))
        if self.Sideband is not None and 'Sideband' not in already_processed:
            already_processed.add('Sideband')
            outfile.write(' Sideband="%s"' % self.gds_format_integer(self.Sideband, input_name='Sideband'))
        if self.SolarCal is not None and 'SolarCal' not in already_processed:
            already_processed.add('SolarCal')
            outfile.write(' SolarCal="%s"' % self.gds_format_integer(self.SolarCal, input_name='SolarCal'))
    def exportChildren(self, outfile, level, namespace_='', name_='ssloType', fromsubclass_=False, pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.freq is not None:
            showIndent(outfile, level, pretty_print)
            outfile.write('<%sfreq>%s</%sfreq>%s' % (namespace_, self.gds_format_double(self.freq, input_name='freq'), namespace_, eol_))
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('Receiver', node)
        if value is not None and 'Receiver' not in already_processed:
            already_processed.add('Receiver')
            self.Receiver = value
        value = find_attr_value_('IFid', node)
        if value is not None and 'IFid' not in already_processed:
            already_processed.add('IFid')
            self.IFid = value
        value = find_attr_value_('Sideband', node)
        if value is not None and 'Sideband' not in already_processed:
            already_processed.add('Sideband')
            try:
                self.Sideband = int(value)
            except ValueError as exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
        value = find_attr_value_('SolarCal', node)
        if value is not None and 'SolarCal' not in already_processed:
            already_processed.add('SolarCal')
            try:
                self.SolarCal = int(value)
            except ValueError as exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'freq':
            sval_ = child_.text
            try:
                fval_ = float(sval_)
            except (TypeError, ValueError) as exp:
                raise_parse_error(child_, 'requires float or double: %s' % exp)
            fval_ = self.gds_validate_float(fval_, node, 'freq')
            self.freq = fval_
# end class ssloType


class coeffType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, order=None, valueOf_=None):
        self.original_tagname_ = None
        self.order = _cast(int, order)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if CurrentSubclassModule_ is not None:
            subclass = getSubclassFromModule_(
                CurrentSubclassModule_, coeffType)
            if subclass is not None:
                return subclass(*args_, **kwargs_)
        if coeffType.subclass:
            return coeffType.subclass(*args_, **kwargs_)
        else:
            return coeffType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_order(self): return self.order
    def set_order(self, order): self.order = order
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def hasContent_(self):
        if (
            1 if type(self.valueOf_) in [int,float] else self.valueOf_
        ):
            return True
        else:
            return False
    def export(self, outfile, level, namespace_='', name_='coeffType', namespacedef_='', pretty_print=True):
        if pretty_print:
            eol_ = '\n'
        else:
            eol_ = ''
        if self.original_tagname_ is not None:
            name_ = self.original_tagname_
        showIndent(outfile, level, pretty_print)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = set()
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='coeffType')
        if self.hasContent_():
            outfile.write('>')
            outfile.write(self.convert_unicode(self.valueOf_))
            self.exportChildren(outfile, level + 1, namespace_='', name_='coeffType', pretty_print=pretty_print)
            outfile.write('</%s%s>%s' % (namespace_, name_, eol_))
        else:
            outfile.write('/>%s' % (eol_, ))
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='coeffType'):
        if self.order is not None and 'order' not in already_processed:
            already_processed.add('order')
            outfile.write(' order="%s"' % self.gds_format_integer(self.order, input_name='order'))
    def exportChildren(self, outfile, level, namespace_='', name_='coeffType', fromsubclass_=False, pretty_print=True):
        pass
    def build(self, node):
        already_processed = set()
        self.buildAttributes(node, node.attrib, already_processed)
        self.valueOf_ = get_all_text_(node)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
        return self
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('order', node)
        if value is not None and 'order' not in already_processed:
            already_processed.add('order')
            try:
                self.order = int(value)
            except ValueError as exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class coeffType


GDSClassesMapping = {
    'coeff': coeffType,
    'dec_polynomial': polyType,
    'dist_polynomial': polyType,
    'ephemeris': ephemerisType,
    'ra_polynomial': polyType,
    'sslo': ssloType,
}


USAGE_TEXT = """
Usage: python <Parser>.py [ -s ] <in_xml_file>
"""


def usage():
    print(USAGE_TEXT)
    sys.exit(1)


def get_root_tag(node):
    tag = Tag_pattern_.match(node.tag).groups()[-1]
    rootClass = GDSClassesMapping.get(tag)
    if rootClass is None:
        rootClass = globals().get(tag)
    return tag, rootClass


def parse(inFileName, silence=False):
    parser = None
    doc = parsexml_(inFileName, parser)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'Observation'
        rootClass = Observation
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
##     if not silence:
##         sys.stdout.write('<?xml version="1.0" ?>\n')
##         rootObj.export(
##             sys.stdout, 0, name_=rootTag,
##             namespacedef_='',
##             pretty_print=True)
    return rootObj


def parseEtree(inFileName, silence=False):
    parser = None
    doc = parsexml_(inFileName, parser)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'Observation'
        rootClass = Observation
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    mapping = {}
    rootElement = rootObj.to_etree(None, name_=rootTag, mapping_=mapping)
    reverse_mapping = rootObj.gds_reverse_node_mapping(mapping)
##     if not silence:
##         content = etree_.tostring(
##             rootElement, pretty_print=True,
##             xml_declaration=True, encoding="utf-8")
##         sys.stdout.write(content)
##         sys.stdout.write('\n')
    return rootObj, rootElement, mapping, reverse_mapping


def parseString(inString, silence=False):
    if sys.version_info.major == 2:
        from StringIO import StringIO as IOBuffer
    else:
        from io import BytesIO as IOBuffer
    parser = None
    doc = parsexml_(IOBuffer(inString), parser)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'Observation'
        rootClass = Observation
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
##     if not silence:
##         sys.stdout.write('<?xml version="1.0" ?>\n')
##         rootObj.export(
##             sys.stdout, 0, name_=rootTag,
##             namespacedef_='')
    return rootObj


def parseLiteral(inFileName, silence=False):
    parser = None
    doc = parsexml_(inFileName, parser)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'Observation'
        rootClass = Observation
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
##     if not silence:
##         sys.stdout.write('#from obsxml_parser import *\n\n')
##         sys.stdout.write('import obsxml_parser as model_\n\n')
##         sys.stdout.write('rootObj = model_.rootClass(\n')
##         rootObj.exportLiteral(sys.stdout, 0, name_=rootTag)
##         sys.stdout.write(')\n')
    return rootObj


def main():
    args = sys.argv[1:]
    if len(args) == 1:
        parse(args[0])
    else:
        usage()


if __name__ == '__main__':
    #import pdb; pdb.set_trace()
    main()


__all__ = [
    "Observation",
    "coeffType",
    "ephemerisType",
    "polyType",
    "ssloType"
]
